/*
 * generated by Xtext 2.27.0
 */
package no.hal.quiz.xtext.serializer;

import com.google.inject.Inject;
import java.util.Set;
import no.hal.quiz.BooleanAnswer;
import no.hal.quiz.ManyOptionsAnswer;
import no.hal.quiz.NumberAnswer;
import no.hal.quiz.Option;
import no.hal.quiz.QA;
import no.hal.quiz.QARef;
import no.hal.quiz.Quiz;
import no.hal.quiz.QuizPackage;
import no.hal.quiz.QuizPart;
import no.hal.quiz.QuizPartRef;
import no.hal.quiz.SingleOptionsAnswer;
import no.hal.quiz.StringAnswer;
import no.hal.quiz.StringQuestion;
import no.hal.quiz.Xml;
import no.hal.quiz.XmlAnswer;
import no.hal.quiz.XmlAttribute;
import no.hal.quiz.XmlContents;
import no.hal.quiz.XmlPIAnswerElement;
import no.hal.quiz.XmlQuestion;
import no.hal.quiz.XmlTag;
import no.hal.quiz.XmlTagElement;
import no.hal.quiz.xtext.services.QuizDSLGrammarAccess;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;

@SuppressWarnings("all")
public class QuizDSLSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private QuizDSLGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == QuizPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case QuizPackage.BOOLEAN_ANSWER:
				sequence_BooleanAnswer(context, (BooleanAnswer) semanticObject); 
				return; 
			case QuizPackage.MANY_OPTIONS_ANSWER:
				sequence_ManyOptionsAnswer(context, (ManyOptionsAnswer) semanticObject); 
				return; 
			case QuizPackage.NUMBER_ANSWER:
				sequence_NumberAnswer(context, (NumberAnswer) semanticObject); 
				return; 
			case QuizPackage.OPTION:
				if (rule == grammarAccess.getManyOptionRule()) {
					sequence_ManyOption(context, (Option) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getSingleBoxOptionRule()) {
					sequence_SingleBoxOption(context, (Option) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getSingleListOptionRule()) {
					sequence_SingleListOption(context, (Option) semanticObject); 
					return; 
				}
				else break;
			case QuizPackage.QA:
				sequence_QA(context, (QA) semanticObject); 
				return; 
			case QuizPackage.QA_REF:
				sequence_QARef(context, (QARef) semanticObject); 
				return; 
			case QuizPackage.QUIZ:
				sequence_Quiz(context, (Quiz) semanticObject); 
				return; 
			case QuizPackage.QUIZ_PART:
				if (rule == grammarAccess.getAnonymousQuizPartRule()) {
					sequence_AnonymousQuizPart(context, (QuizPart) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getAbstractQuizPartRule()
						|| rule == grammarAccess.getQuizPartRule()) {
					sequence_QuizPart(context, (QuizPart) semanticObject); 
					return; 
				}
				else break;
			case QuizPackage.QUIZ_PART_REF:
				sequence_QuizPartRef(context, (QuizPartRef) semanticObject); 
				return; 
			case QuizPackage.SINGLE_OPTIONS_ANSWER:
				if (rule == grammarAccess.getAnswerRule()
						|| rule == grammarAccess.getOptionsAnswerRule()
						|| rule == grammarAccess.getSingleOptionsAnswerRule()) {
					sequence_SingleBoxOptionsAnswer_SingleListOptionsAnswer(context, (SingleOptionsAnswer) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getSingleBoxOptionsAnswerRule()) {
					sequence_SingleBoxOptionsAnswer(context, (SingleOptionsAnswer) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getSingleListOptionsAnswerRule()) {
					sequence_SingleListOptionsAnswer(context, (SingleOptionsAnswer) semanticObject); 
					return; 
				}
				else break;
			case QuizPackage.STRING_ANSWER:
				if (rule == grammarAccess.getRegexAnswerRule()) {
					sequence_RegexAnswer(context, (StringAnswer) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getAnswerRule()
						|| rule == grammarAccess.getOptionAnswerRule()
						|| rule == grammarAccess.getSimpleAnswerRule()) {
					sequence_RegexAnswer_StringAnswer(context, (StringAnswer) semanticObject); 
					return; 
				}
				else if (rule == grammarAccess.getStringAnswerRule()) {
					sequence_StringAnswer(context, (StringAnswer) semanticObject); 
					return; 
				}
				else break;
			case QuizPackage.STRING_QUESTION:
				sequence_StringQuestion(context, (StringQuestion) semanticObject); 
				return; 
			case QuizPackage.XML:
				sequence_Xml(context, (Xml) semanticObject); 
				return; 
			case QuizPackage.XML_ANSWER:
				sequence_XmlAnswer(context, (XmlAnswer) semanticObject); 
				return; 
			case QuizPackage.XML_ATTRIBUTE:
				sequence_XmlAttribute(context, (XmlAttribute) semanticObject); 
				return; 
			case QuizPackage.XML_CONTENTS:
				sequence_XmlContents(context, (XmlContents) semanticObject); 
				return; 
			case QuizPackage.XML_PI_ANSWER_ELEMENT:
				sequence_XmlPIAnswerElement(context, (XmlPIAnswerElement) semanticObject); 
				return; 
			case QuizPackage.XML_QUESTION:
				sequence_XmlQuestion(context, (XmlQuestion) semanticObject); 
				return; 
			case QuizPackage.XML_TAG:
				sequence_XmlTag(context, (XmlTag) semanticObject); 
				return; 
			case QuizPackage.XML_TAG_ELEMENT:
				sequence_XmlTagElement(context, (XmlTagElement) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * <pre>
	 * Contexts:
	 *     AnonymousQuizPart returns QuizPart
	 *
	 * Constraint:
	 *     questions+=AbstractQA*
	 * </pre>
	 */
	protected void sequence_AnonymousQuizPart(ISerializationContext context, QuizPart semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Answer returns BooleanAnswer
	 *     OptionAnswer returns BooleanAnswer
	 *     SimpleAnswer returns BooleanAnswer
	 *     BooleanAnswer returns BooleanAnswer
	 *
	 * Constraint:
	 *     (value?='yes' | value?='true')?
	 * </pre>
	 */
	protected void sequence_BooleanAnswer(ISerializationContext context, BooleanAnswer semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     ManyOption returns Option
	 *
	 * Constraint:
	 *     (correct?='x'? option=OptionAnswer)
	 * </pre>
	 */
	protected void sequence_ManyOption(ISerializationContext context, Option semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Answer returns ManyOptionsAnswer
	 *     OptionsAnswer returns ManyOptionsAnswer
	 *     ManyOptionsAnswer returns ManyOptionsAnswer
	 *
	 * Constraint:
	 *     options+=ManyOption+
	 * </pre>
	 */
	protected void sequence_ManyOptionsAnswer(ISerializationContext context, ManyOptionsAnswer semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Answer returns NumberAnswer
	 *     OptionAnswer returns NumberAnswer
	 *     SimpleAnswer returns NumberAnswer
	 *     NumberAnswer returns NumberAnswer
	 *
	 * Constraint:
	 *     (value=EDoubleObject errorMargin=EDoubleObject?)
	 * </pre>
	 */
	protected void sequence_NumberAnswer(ISerializationContext context, NumberAnswer semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     AbstractQA returns QARef
	 *     QARef returns QARef
	 *
	 * Constraint:
	 *     qaRef=[QA|QName]
	 * </pre>
	 */
	protected void sequence_QARef(ISerializationContext context, QARef semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, QuizPackage.Literals.QA_REF__QA_REF) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, QuizPackage.Literals.QA_REF__QA_REF));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getQARefAccess().getQaRefQAQNameParserRuleCall_1_0_1(), semanticObject.eGet(QuizPackage.Literals.QA_REF__QA_REF, false));
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     AbstractQA returns QA
	 *     QA returns QA
	 *
	 * Constraint:
	 *     (name=ID? q=Question a=Answer)
	 * </pre>
	 */
	protected void sequence_QA(ISerializationContext context, QA semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     AbstractQuizPart returns QuizPartRef
	 *     QuizPartRef returns QuizPartRef
	 *
	 * Constraint:
	 *     partRef=[QuizPart|QName]
	 * </pre>
	 */
	protected void sequence_QuizPartRef(ISerializationContext context, QuizPartRef semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, QuizPackage.Literals.QUIZ_PART_REF__PART_REF) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, QuizPackage.Literals.QUIZ_PART_REF__PART_REF));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getQuizPartRefAccess().getPartRefQuizPartQNameParserRuleCall_2_0_1(), semanticObject.eGet(QuizPackage.Literals.QUIZ_PART_REF__PART_REF, false));
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     AbstractQuizPart returns QuizPart
	 *     QuizPart returns QuizPart
	 *
	 * Constraint:
	 *     (name=ID title=STRING questions+=AbstractQA*)
	 * </pre>
	 */
	protected void sequence_QuizPart(ISerializationContext context, QuizPart semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Quiz returns Quiz
	 *
	 * Constraint:
	 *     ((name=QName? title=STRING? parts+=AbstractQuizPart*) | parts+=AnonymousQuizPart)?
	 * </pre>
	 */
	protected void sequence_Quiz(ISerializationContext context, Quiz semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     RegexAnswer returns StringAnswer
	 *
	 * Constraint:
	 *     (regexp?='/' value=STRING ignoreCase?='~'?)
	 * </pre>
	 */
	protected void sequence_RegexAnswer(ISerializationContext context, StringAnswer semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Answer returns StringAnswer
	 *     OptionAnswer returns StringAnswer
	 *     SimpleAnswer returns StringAnswer
	 *
	 * Constraint:
	 *     ((value=STRING ignoreCase?='~'?) | (regexp?='/' value=STRING ignoreCase?='~'?))
	 * </pre>
	 */
	protected void sequence_RegexAnswer_StringAnswer(ISerializationContext context, StringAnswer semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     SingleBoxOption returns Option
	 *
	 * Constraint:
	 *     (correct?='x'? option=OptionAnswer)
	 * </pre>
	 */
	protected void sequence_SingleBoxOption(ISerializationContext context, Option semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Answer returns SingleOptionsAnswer
	 *     OptionsAnswer returns SingleOptionsAnswer
	 *     SingleOptionsAnswer returns SingleOptionsAnswer
	 *
	 * Constraint:
	 *     (options+=SingleBoxOption+ | options+=SingleListOption+)
	 * </pre>
	 */
	protected void sequence_SingleBoxOptionsAnswer_SingleListOptionsAnswer(ISerializationContext context, SingleOptionsAnswer semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     SingleBoxOptionsAnswer returns SingleOptionsAnswer
	 *
	 * Constraint:
	 *     options+=SingleBoxOption+
	 * </pre>
	 */
	protected void sequence_SingleBoxOptionsAnswer(ISerializationContext context, SingleOptionsAnswer semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     SingleListOption returns Option
	 *
	 * Constraint:
	 *     (correct?='v'? option=OptionAnswer)
	 * </pre>
	 */
	protected void sequence_SingleListOption(ISerializationContext context, Option semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     SingleListOptionsAnswer returns SingleOptionsAnswer
	 *
	 * Constraint:
	 *     options+=SingleListOption+
	 * </pre>
	 */
	protected void sequence_SingleListOptionsAnswer(ISerializationContext context, SingleOptionsAnswer semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     StringAnswer returns StringAnswer
	 *
	 * Constraint:
	 *     (value=STRING ignoreCase?='~'?)
	 * </pre>
	 */
	protected void sequence_StringAnswer(ISerializationContext context, StringAnswer semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Question returns StringQuestion
	 *     StringQuestion returns StringQuestion
	 *
	 * Constraint:
	 *     question=STRING
	 * </pre>
	 */
	protected void sequence_StringQuestion(ISerializationContext context, StringQuestion semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, QuizPackage.Literals.STRING_QUESTION__QUESTION) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, QuizPackage.Literals.STRING_QUESTION__QUESTION));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getStringQuestionAccess().getQuestionSTRINGTerminalRuleCall_0(), semanticObject.getQuestion());
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Answer returns XmlAnswer
	 *     OptionAnswer returns XmlAnswer
	 *     XmlAnswer returns XmlAnswer
	 *
	 * Constraint:
	 *     xml=Xml
	 * </pre>
	 */
	protected void sequence_XmlAnswer(ISerializationContext context, XmlAnswer semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, QuizPackage.Literals.XML_ANSWER__XML) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, QuizPackage.Literals.XML_ANSWER__XML));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getXmlAnswerAccess().getXmlXmlParserRuleCall_0(), semanticObject.getXml());
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     XmlAttribute returns XmlAttribute
	 *
	 * Constraint:
	 *     (name=ID value=STRING)
	 * </pre>
	 */
	protected void sequence_XmlAttribute(ISerializationContext context, XmlAttribute semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, QuizPackage.Literals.XML_ATTRIBUTE__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, QuizPackage.Literals.XML_ATTRIBUTE__NAME));
			if (transientValues.isValueTransient(semanticObject, QuizPackage.Literals.XML_ATTRIBUTE__VALUE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, QuizPackage.Literals.XML_ATTRIBUTE__VALUE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getXmlAttributeAccess().getNameIDTerminalRuleCall_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getXmlAttributeAccess().getValueSTRINGTerminalRuleCall_2_0(), semanticObject.getValue());
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     XmlContents returns XmlContents
	 *
	 * Constraint:
	 *     (element=XmlElement post=XML_TEXT)
	 * </pre>
	 */
	protected void sequence_XmlContents(ISerializationContext context, XmlContents semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, QuizPackage.Literals.XML_CONTENTS__ELEMENT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, QuizPackage.Literals.XML_CONTENTS__ELEMENT));
			if (transientValues.isValueTransient(semanticObject, QuizPackage.Literals.XML_CONTENTS__POST) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, QuizPackage.Literals.XML_CONTENTS__POST));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getXmlContentsAccess().getElementXmlElementParserRuleCall_0_0(), semanticObject.getElement());
		feeder.accept(grammarAccess.getXmlContentsAccess().getPostXML_TEXTTerminalRuleCall_1_0(), semanticObject.getPost());
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     XmlElement returns XmlPIAnswerElement
	 *     XmlPIAnswerElement returns XmlPIAnswerElement
	 *
	 * Constraint:
	 *     answer=SimpleAnswer
	 * </pre>
	 */
	protected void sequence_XmlPIAnswerElement(ISerializationContext context, XmlPIAnswerElement semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, QuizPackage.Literals.XML_PI_ANSWER_ELEMENT__ANSWER) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, QuizPackage.Literals.XML_PI_ANSWER_ELEMENT__ANSWER));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getXmlPIAnswerElementAccess().getAnswerSimpleAnswerParserRuleCall_1_0(), semanticObject.getAnswer());
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Question returns XmlQuestion
	 *     XmlQuestion returns XmlQuestion
	 *
	 * Constraint:
	 *     xml=Xml
	 * </pre>
	 */
	protected void sequence_XmlQuestion(ISerializationContext context, XmlQuestion semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, QuizPackage.Literals.XML_QUESTION__XML) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, QuizPackage.Literals.XML_QUESTION__XML));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getXmlQuestionAccess().getXmlXmlParserRuleCall_0(), semanticObject.getXml());
		feeder.finish();
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     XmlElement returns XmlTagElement
	 *     XmlTagElement returns XmlTagElement
	 *
	 * Constraint:
	 *     (startTag=XmlTag (pre=XML_TEXT contents+=XmlContents* endTag=ID?)?)
	 * </pre>
	 */
	protected void sequence_XmlTagElement(ISerializationContext context, XmlTagElement semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     XmlTag returns XmlTag
	 *
	 * Constraint:
	 *     (name=ID attributes+=XmlAttribute*)
	 * </pre>
	 */
	protected void sequence_XmlTag(ISerializationContext context, XmlTag semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * <pre>
	 * Contexts:
	 *     Xml returns Xml
	 *
	 * Constraint:
	 *     element=XmlElement
	 * </pre>
	 */
	protected void sequence_Xml(ISerializationContext context, Xml semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, QuizPackage.Literals.XML__ELEMENT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, QuizPackage.Literals.XML__ELEMENT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getXmlAccess().getElementXmlElementParserRuleCall_1_0(), semanticObject.getElement());
		feeder.finish();
	}
	
	
}
